#include "Reticolo.hh"
#include <iostream>

using namespace std;

Reticolo::Reticolo() {
    for (int i=0;i<10;i++) {
        for (int j=0;j<10;j++) {
            matrix[i][j] = '.';
        }
    }
}

void Reticolo::setLive(int r, int c, char b) {
    matrix[r][c] = b;
}

char Reticolo::getLive(int r, int c) {
    return matrix[r][c];
}

int Reticolo::getLiveNeightbor(int r, int c) {
    int n = 0;
    for ( int i=-1;i<2;i++ ) {
        for ( int j=-1;j<2;j++ ) {
            int tr = r+i;
            if ( tr < 0 ) tr += 10;
            if ( tr > 9 ) tr -= 10;
            int tc = c+j;
            if ( tc < 0 ) tc += 10;
            if ( tc > 9 ) tc -= 10;
            if ( tr == r && tc == c ) continue;
            if ( matrix[tr][tc] == '*') n++;
        }
    }
    return n;
}

void Reticolo::dump() {
    for (int i=0;i<10;i++) {
        for (int j=0;j<10;j++) {
            cout << matrix[i][j] << " ";
        }
        cout << endl;
    }
}
