#include "Evoluzione.hh"

Evoluzione::Evoluzione ( Reticolo * r ) {
    world = r;
}

void Evoluzione::next() {
    for (int i=0;i<10;i++) {
        for (int j=0;j<10;j++) {
            tmpWorld.setLive(i,j,'.');
            int n = world->getLiveNeightbor(i,j);
            if ( world->getLive(i,j) == '.') {
                if ( n == 3 ) tmpWorld.setLive(i,j,'*');
            } else {
                if ( n == 2 || n == 3 ) tmpWorld.setLive(i,j,'*');
                if ( n > 3 || n < 2 ) tmpWorld.setLive(i,j,'.');
            }
        }
    }
    swapWorld();
}

void Evoluzione::swapWorld() {
    for (int i=0;i<10;i++) {
        for (int j=0;j<10;j++) {
            world->setLive(i,j,tmpWorld.getLive(i,j));
        }
    }
}
