(******** es. 1  ******)
g1 = ParametricPlot3D[ {r Cos[phi], r Sin[phi], r}, {r,-2.5,2.5}, {phi,0,2 Pi}];

g[lambda_] := Plot3D[ 1/2 + lambda x, {x,-2,2}, {y,-2,2},DisplayFunction->Identity ];

Show[ g1,g[0]];
Show[ g1,g[0.5]];
Show[ g1,g[1]];
Show[ g1,g[2]];


(******** es. 2  ******)

sol[lambda_] = Solve[ {z==1/2 + lambda x, z^2 == x^2 + y^2}, {z,y} ];

g2[lambda_] := Plot[ Evaluate[ y /. sol[lambda] ], {x,-3,3} ];

g2[0];
g2[0.5];
g2[1];
g2[2];


(******** es. 3  ******)

sol[k12_] = 
DSolve[ {y1''[x] == -y1[x] + k12 (y2[x]-y1[x]),
         y2''[x] == -y2[x] - k12 (y2[x]-y1[x]),
         y1[0]==0.5, y2[0]==0, y1'[0]==0, y2'[0]==0},
        {y1[x], y2[x]}, x];

g3 = Plot[ {y1[x] /. sol[0.01], y1[x] /. sol[0.1]}, {x,0,200}];


(******** es. 4  ******)

sub = {Cos[a_ + b_] -> Cos[a] Cos[b] -Sin[a] Sin[b]};


Unprotect[ Cos];
Cos[a_ + b_] := Cos[a] Cos[b] -Sin[a] Sin[b];
Protect[Cos];
